import { EventEmitter } from "events";
export interface WSReqonetOptions {
    /** # of times to reconnect within a retry */
    maxReconnectAttempts?: number;
    /** # of attempts at reconnecting */
    maxRetryAttempts?: number;
    /** Whether to store 'send' data when connection is broken  */
    queueMessage?: boolean;
    /** whether to disable reconnection */
    disableReconnect?: boolean;
    /** enable to get console.log output */
    debug?: boolean;
}
export default class WSReqonet extends EventEmitter {
    private protocols;
    private ws;
    private reconnectAttempts;
    private maxReconnectAttempts;
    private retryAttempts;
    private maxRetryAttempts;
    private intervalRef;
    private messageQueue;
    private queueMessage;
    private forcedClose;
    private disableReconnect;
    constructor(url: string | URL, protocols?: string | string[], options?: WSReqonetOptions);
    private onOpen;
    private onMessage;
    private onError;
    private onClose;
    send: WebSocket["send"];
    close: WebSocket["close"];
    private connect;
    /** relay messages that were queued while the connection was closed */
    private relayQueuedMessages;
    private reconnect;
    private onRestore;
    /** check if connection is open */
    isOpen: () => boolean;
}
